angular.module("optimizelyApp").factory('Project', ['$http', 'Constants', function($http, Constants) {
  var projectInstance = {};
  
  projectInstance.getInitialData = $http.get(Constants.baseUrl+'GetInitialData');
  //projectInstance.getInitialData = $http.get(Constants.localUrl+'GetInitialData.json');

  function refreshProjects(clearCache = false, projectId = null, tabSelected = null){
    console.log('refreshing project!!');
    console.log('projectId: ' + projectId);
    console.log('tabSelected: ' + tabSelected);
    return $http.get(Constants.baseUrl+'GetInitialData?projectId='+projectId+'&tab='+tabSelected+'&forceRefreshCache='+clearCache);
  } 
  
  function getExperimentByProject(projectId){
    return $http.get(Constants.baseUrl+'GetExperimentsProject?projectId='+projectId);
  } 

  function getPagesByProject(projectId, flag= false){
    return $http.get(Constants.baseUrl+'GetPagesProject?projectId='+projectId+'&forceRefreshCache='+flag);
  } 

  function getEventsByProject(projectId){
    return $http.get(Constants.baseUrl+'GetEventsProject?projectId='+projectId);
  } 

  function getAudiencesByProject(projectId){
    return $http.get(Constants.baseUrl+'GetAudienceProject?projectId='+projectId);
  }
  
  projectInstance.getProjectById = function(projects, id){
      var project = null;
      for (var index = 0; index < projects.length; index++) {
          if(id == projects[index].ProjectId){
              project = projects[index];
              break;
          }
          
      }
      return project;

  }

  function setWinner(data) {      
      var setWinnerPromise = $http.post(Constants.baseUrl+'SetWinner', data);
      return setWinnerPromise;
  }

  projectInstance.refreshProjects = refreshProjects;
  projectInstance.setWinner = setWinner;
  projectInstance.getExperimentByProject = getExperimentByProject;
  projectInstance.getPagesByProject = getPagesByProject;
  projectInstance.getEventsByProject = getEventsByProject;
  projectInstance.getAudiencesByProject = getAudiencesByProject;

  return projectInstance;
}]);