angular.module("optimizelyApp").filter('startFrom', function() {
    return function(input, start) {
        start = +start; //parse to int
        return input.slice(start);
    }
});

angular.module("optimizelyApp").controller("projectsCtrl", function ($scope, $http, Constants, Project, Experiment, $filter) {

    $scope.title = "Projects";
    $scope.projects = [];
    $scope.selectedProject = "";
    $scope.currentProject = {};
    $scope.currentProject.Pages = [];
    $scope.currentProject.Events = [];
    $scope.currentProject.Audiences = [];
    $scope.currentExperiment = {};
    $scope.error = '';


    //Pagination
    $scope.currentPage = 0;
    $scope.pageSize = 10;
    $scope.data = [];
    $scope.q = '';

    $scope.getData = function () {
      // needed for the pagination calc
      // https://docs.angularjs.org/api/ng/filter/filter
      return $filter('filter')($scope.data, $scope.q)
     /*
       // manual filter
       // if u used this, remove the filter from html, remove above line and replace data with getData()

        var arr = [];
        if($scope.q == '') {
            arr = $scope.data;
        } else {
            for(var ea in $scope.data) {
                if($scope.data[ea].indexOf($scope.q) > -1) {
                    arr.push( $scope.data[ea] );
                }
            }
        }
        return arr;
       */
    }

    $scope.numberOfPages=function(){
        return Math.ceil($scope.getData().length/$scope.pageSize);
    }

    for (var i=0; i<65; i++) {
        $scope.data.push("Item "+i);
    }

    $scope.tabSelected = 'experiments';

    $scope.initPromise = Project.getInitialData;
    $scope.experimentPromise = $http.get('/');

    $scope.initPromise.then(
        function (response) {
           
           $scope.projects = response.data;
            if(($scope.projects.success == false)||($scope.projects == "")){
               $('.promise').hide();
               showDialog('error', 'Sorry there was an error, please check your data');
            }
			if ($scope.projects.errorLicence == true){
               $('.promise').hide();
  			   $('.ui-dialog').hide();
			        showDialogWithButtons(
                        'Error',
                        $scope.projects.error,
                        function () {
							window.open($scope.projects.url);
                        },
                        function () {
                             $(this).dialog("close");
						},
						$scope.projects.buttonName
					);
            }
            else{
               $scope.currentProject = $scope.projects[0];
               $scope.selectedProject = $scope.projects[0].ProjectId;
               $scope.currentExperiment = $scope.projects[0].Experiments[0];
               $scope.error = '';
               //$scope.$apply();                
            }

    }, function (response) {
        $scope.error = 'An error has occurred. Check the logs for more information.';
    });

    $scope.updateProject = function(project){


        $scope.currentProject = Project.getProjectById($scope.projects, project);

        $scope.initPromise = Project.getExperimentByProject(project);

        $scope.initPromise.then(
            function (response) {
            $scope.currentProject.Experiments = response.data;

            //$scope.$apply();

        }, function (response) {
            $scope.currentProject.Experiments = [];
        });

        $scope.selectedProject =  project;

        //this could be change
        $scope.changeTab('experiments');



    }

    $scope.refreshProjects = function(){
        $scope.initPromise = Project.refreshProjects(true, $scope.selectedProject, $scope.tabSelected);
        $scope.initPromise.then(
        function (response) {
			//console.log($scope.projects[0] , $scope.projects[0].ProjectId);
            $scope.projects = response.data;
		    if(($scope.projects[0] == null)|| ($scope.projects[0] == "") ){
               $('.promise').hide();
               showDialog('error', 'The Optimizely server cannot be reached at this time. Please try again or contact Optimizely support.');
            }
            $scope.currentProject = $scope.projects[0];
            $scope.selectedProject = $scope.projects[0].ProjectId;
            if($scope.projects[0].Experiments){
                $scope.currentExperiment = $scope.projects[0].Experiments[0];
            }
            $scope.error = '';
            //$scope.$apply();
            if(($scope.projects.success == false)||($scope.projects == "")){
				console.log($scope.projects);
               $('.promise').hide();
               showDialog('error', 'Sorry there was an error, please check your data');
            }

        }, function (response) {
            $scope.error = 'An error has occurred. Check the logs for more information.';
        });
    }

    $scope.initSelect = function(){
    }

    $scope.checkParentClass = function(id){
        return !angular.element('#'+id).parents("section").hasClass( "ac_hidden" );
    }

    $scope.selectExperiment = function(id){
        angular.element('#'+id).parents().siblings("section").addClass("ac_hidden");
        angular.element('#'+id).parents("section").removeClass("ac_hidden");
        if($scope.currentExperiment.ExperimentId != id){
            $scope.experimentPromise = Experiment.getExperimentById(id);

            $scope.experimentPromise.then(
                function (response) {
                $scope.currentExperiment = response.data;
                if(response.data.success == false){
                    showDialog('error', 'Sorry there was an error, please check your data');
                    //$('.pages_content').hide();
                } 

                //$scope.$apply();

            }, function (response) {
                $scope.currentExperiment = {};
            });
        }
    }

    $scope.refreshExperiment = function(experimentId){

        $scope.experimentPromise = Experiment.getExperimentById(experimentId, true);

            $scope.experimentPromise.then(
                function (response) {
                $scope.currentExperiment = response.data;

                //$scope.$apply();

            }, function (response) {
                 $scope.currentExperiment = {};
            });
    }

    $scope.refreshPages = function(){

        $scope.initPromise = Project.getPagesByProject($scope.selectedProject, true);

        $scope.initPromise.then(
            function (response) {
            $scope.currentProject.Pages = response.data;
            //$scope.$apply();

        }, function (response) {
            $scope.currentProject.Pages = [];
        });
    }

    $scope.selectEvent = function(id){
        angular.element('#'+id).parents().siblings("section").addClass("ac_hidden");
        angular.element('#'+id).parents("section").removeClass("ac_hidden");
    }

    $scope.changeTab = function(id){
        angular.element('#'+id).siblings("li").removeClass("epi-tabView-navigation-item-selected");
        angular.element('#'+id).siblings("li").addClass("epi-tabView-navigation-item");
        angular.element('#'+id).removeClass("epi-tabView-navigation-item");
        angular.element('#'+id).addClass("epi-tabView-navigation-item-selected");
        $scope.tabSelected = id;

        switch (id) {
            case 'pages':
                $scope.initPromise = Project.getPagesByProject($scope.selectedProject);

                $scope.initPromise.then(
                    function (response) {
                        if(response.data.success == false){
                           showDialog('error', 'Sorry there was an error, please check your data');
                           $('.pages_content').hide();
                        } 
                    $scope.currentProject.Pages = response.data;

                }, function (response) {
                    $scope.currentProject.Pages = [];
                });

                break;

            case 'events':
                $scope.initPromise = Project.getEventsByProject($scope.selectedProject);

                $scope.initPromise.then(
                    function (response) {
                    $scope.currentProject.Events = response.data;
                    //$scope.$apply();
                    if(response.data.success == false){
                        showDialog('error', 'Sorry there was an error, please check your data');
                        $('.events_content').hide();
                    }

                }, function (response) {
                    $scope.currentProject.Events = [];
                });

                break;

            case 'audiences':
                $scope.initPromise = Project.getAudiencesByProject($scope.selectedProject);

                $scope.initPromise.then(
                    function (response) {
                    $scope.currentProject.Audiences = response.data;
                    //$scope.$apply();
                    if(response.data.success == false){
                        showDialog('error', 'Sorry there was an error, please check your data');
                        $('.audiences_content').hide();
                    }

                }, function (response) {
                    $scope.currentProject.Audiences = [];
                });

                break;

             case 'experiments':
                $scope.initPromise = Project.getExperimentByProject($scope.selectedProject);

                $scope.initPromise.then(
                    function (response) {
                    $scope.currentProject.Experiments = response.data;
                    if(response.data.success == false){
                       showDialog('error', 'Sorry there was an error, please check your data');
                       $('#accordion').hide();
                    }    
                    //$scope.$apply();

                }, function (response) {
                    $scope.currentProject.Experiments = [];
                });

                break;


            //Me quede aqui en el caso que seleccionen experiments!!!!!!!!!!!!

            default:
                break;
        }
    }

    $scope.setAsWinner = function(projectId, experimentId, variationId){
        /*
        var data = $.param({
            projectId: projectId,
            experimentId: experimentId,
            variationId: variationId
        });
        */

        var data = {
                projectId: projectId,
                experimentId: experimentId,
                variationId: variationId
            };


        $.ajax({
            type: 'POST',
            url: '/OptimizelyIntegration/SetWinner',
            //contentType: 'text/plain',
            dataType: 'json',
            data: { 'projectId': projectId, 'experimentId': experimentId, 'variationId': variationId },
            xhr: function () {
                var xhr = jQuery.ajaxSettings.xhr();
                var setRequestHeader = xhr.setRequestHeader;
                xhr.setRequestHeader = function (name, value) {
                    if (name == 'X-Requested-With') return;
                    setRequestHeader.call(this, name, value);
                }
                return xhr;
            },
            success: function (data) {
                showDialog('Information', 'Winner published');
				if(data.success == false){
					showDialog('Error', 'Sorry there was an error, please check your data');
				}
                return true;

            },

            error: function () {
                showDialog('Error', 'Sorry there was an error, please check your data');
                return false;
            }
        });

        /*
         Project.setWinner(JSON.stringify(data)).then(
            function (response) {
               console.log("SetWinner success");
               console.log(response);

            }, function (response) {
                console.log("SetWinner Error in request");
                console.log(response);
            });
            */
    }

    function showDialog(title, message) {
        $("#dialogMessage").html(message);
        $("#dialog").dialog("option", "title", title);
        $("#dialog").dialog("open");
    }
	function showDialogWithButtons(title, message, callbackOk, callbackCancel, btn) {

    $("#dialogWithButtons").dialog("option", "buttons",
      [
        {
            text: btn,
            click: callbackOk
        }
      ]
    );

    $("#dialogWithButtonsMessage").html(message)
    $("#dialogWithButtons").dialog("option", "title", title);
    $("#dialogWithButtons").dialog("open");
}

    $scope.redirectLogo = function() {
        var win = window.open("https://app.optimizely.com/", '_blank');
        if (win) {
            //Browser has allowed it to be opened
            win.focus();
        } else {
            //Browser has blocked it
            alert('Please allow popups for this website');
        }
    }


});
