function CheckJS() {
    return false
}

function setCookie(key, value) {
    var expires = new Date();
    expires.setTime(expires.getTime() + (1 * 24 * 60 * 60 * 1000));
    document.cookie = key + '=' + value + ';expires=' + expires.toUTCString();
}

function getCookie(key) {
    var keyValue = document.cookie.match('(^|;) ?' + key + '=([^;]*)(;|$)');
    return keyValue ? keyValue[2] : null;
}

var COMPARISON = {
    LESS_THAN: 'Less',
    EQUAL: 'Equal',
    MORE_THAN: 'More'
};

var TIME_FRAME_SELECTION = {
    SINCE: 'Since',
    TOTAL: 'Total',
    WHITIN: 'Within'
};

var FLOAT_TIME_PERIOD = {
    DAY: 'Day',
    MONTH: 'Month',
    WEEK: 'Week',
    YEAR: 'Year'
};

var DATE_CRITERIA = null;

/*
this make a synchronous request to the server, not recommend
*/
function executeCustomFunctionServer(visitorGroupId) {
	
    var http = new XMLHttpRequest();
    var url = "/OptimizelyIntegration/GetResultNumberOfVisitsCriteria";
    var params = "visitorGroupId=" + visitorGroupId;
    http.open("POST", url, false);
    http.setRequestHeader("Content-type", "application/x-www-form-urlencoded");

    http.send(params);
    var result = http.responseText;
    
    return result == 'true';
}

/**
 * This function generate an audience to be use from the optimizely
 * @param {COMPARISON} comparison 
 * @param {Number} threshold
 * @param {TIME_FRAME_SELECTION} timeFrameSelection
 * @param {Number} floatTimeValue
 * @param {FLOAT_TIME_PERIOD} floatTimePeriod
 * @param {Number} fixTime
 * @return {Boolean} value
 */
function generateAudienceforNumberOfVisits(comparison, threshold, timeFrameSelection, floatTimeValue, floatTimePeriod, fixTime) {
   floatTimeValue = floatTimeValue == -1 ? false : floatTimeValue;
   floatTimePeriod = floatTimePeriod == "" ? false : floatTimeValue;
   fixTime = fixTime == "" ? false : fixTime;

   var numberOfVisitsCookie = getCookie("EPi_NumberOfVisits");
   var arrayOfDates = [];
   parsedCookie = parseCookieToDates(numberOfVisitsCookie);
   var number = parsedCookie.numberOfVisit;

   switch (timeFrameSelection) {
       case TIME_FRAME_SELECTION.SINCE:
        {
            console.log('TIME_FRAME_SELECTION.SINCE');
            var sinceDate = parseDate(fixTime);
            var visitSince = GetVisitsSince(parsedCookie.arrayOfDates, sinceDate);
            return isMatch(comparison, visitSince.length, threshold);
        }
       case TIME_FRAME_SELECTION.TOTAL:
        {
            console.log('TIME_FRAME_SELECTION.TOTAL');
            return isMatch(comparison, number, threshold);            
        }
       case TIME_FRAME_SELECTION.WHITIN:
        {
            console.log('TIME_FRAME_SELECTION.WHITIN');
            var time_period = getTimePeriod(floatTimeValue, floatTimePeriod);
            console.log(time_period);
            var visitSince = GetVisitsSince(parsedCookie.arrayOfDates, time_period);
            console.log(visitSince);
            return isMatch(comparison, visitSince.length, threshold);
        }
   }
}


/**
 * This function return a parsed Object from the cookie
 * @param {string} cookie 
 * @return {Object} result
 * @return {Number} result.numberOfVisit
 * @return {Dates[} result.arrayOfDates
 */
function parseCookieToDates(cookie) {
    var result = {};

    result.numberOfVisit = 0;
    result.arrayOfDates = [];

    var res = cookie.split(",");

    result.numberOfVisit = Number(res[0]);

    for (var i = 1; i < res.length; i++) {
        result.arrayOfDates.push(new Date(res[i]));
    }

    return result;
}

/**
 * This function return a parsed Object from the cookie
 * @param {string} cookie 
 * @return {Object} result
 * @return {Number} result.numberOfVisit
 * @return {Dates[} result.arrayOfDates
 */
function getTimePeriod(floatTimeValue, floatTimePeriod) {
    var time_period = 0;
    var date = new Date();
    switch (floatTimePeriod) {
        case FLOAT_TIME_PERIOD.DAY:
        {
            var dateOffset = (24 * 60 * 60 * 1000) * floatTimeValue; // floatTimeValue in days
            date.setTime(date.getTime() - dateOffset);
            //time_period = date.getTime(); doesn't work because the comparison is in date not in milisecond
            return date;
        }
        case FLOAT_TIME_PERIOD.MONTH:
        {
            var dateOffset = (30 * 24 * 60 * 60 * 1000) * floatTimeValue; // floatTimeValue in months
            date.setTime(date.getTime() - dateOffset);
            return date;
        }
        case FLOAT_TIME_PERIOD.WEEK:
        {
            var dateOffset = (7 * 24 * 60 * 60 * 1000) * floatTimeValue; // floatTimeValue in weeks
            date.setTime(date.getTime() - dateOffset);
            return date;
        }
        case FLOAT_TIME_PERIOD.YEAR:
        {
            var dateOffset = (365 * 24 * 60 * 60 * 1000) * floatTimeValue; // floatTimeValue in years
            date.setTime(date.getTime() - dateOffset);
            return date;
        }
    }
    return time_period;
}

/**
 * This function return a parsed Object from the cookie
 * @param {string} cookie 
 * @return {Object} result
 * @return {Number} result.numberOfVisit
 * @return {Dates[} result.arrayOfDates
 */
function isMatch(comparison, number, threshold) {
    switch (comparison) {
        case COMPARISON.LESS_THAN:
        {
            return number < threshold;
        }
        case COMPARISON.EQUAL:
        {
            return number == threshold;
        }
        case COMPARISON.MORE_THAN:
        {
            return number > threshold;
        }
    }
    return false;
}

/**
 * This function return the number of visits
 * @param {string} cookie 
 * @return {Object} result
 * @return {Number} result.numberOfVisit
 * @return {Dates[} result.arrayOfDates
 */
function GetVisitsWithin(sessions, floatTimeValue, floatTimePeriod)
{
    var result = 0;
    return result;
}

/**
 * This function return the number of visits
 * @param {string} cookie 
 * @return {Object} result
 * @return {Number} result.numberOfVisit
 * @return {Dates[} result.arrayOfDates
 */
function GetVisitsSince(sessions, fixTime) {
    var result = [];
    DATE_CRITERIA = fixTime;
    result = sessions.filter(compareDate);
    return result;
}

/**
 * This function parse the date in format: ddmmYYYY
 * @param {string} stringDate 
 * @return {Date} date
 */
function parseDate(stringDate) {
    var pattern = /(\d{2})(\d{2})(\d{4})/;
    var temp = new Date(stringDate.replace(pattern, '$3-$2-$1'));
    var date = new Date(temp.getFullYear(), temp.getMonth(), temp.getDate() + 1);
    return date;
}

function getDateDifferenceDays(date1, date2) {
    var timeDiff = Math.abs(date2.getTime() - date1.getTime());
    var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
    return diffDays;
}

function getDateDifference(date1, date2) {
    var timeDiff = date2.getTime() - date1.getTime();
    return timeDiff;
}

function compareDate(date) {
    var difference = getDateDifference(DATE_CRITERIA, date)
    return difference >= 0;
}